回溯——491.递增子序列

Posted Mirror559

tags:

篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了回溯——491.递增子序列相关的知识,希望对你有一定的参考价值。

给定一个整型数组, 你的任务是找到所有该数组的递增子序列,递增子序列的长度至少是2。

示例:

  • 输入: [4, 6, 7, 7]
  • 输出: [[4, 6], [4, 7], [4, 6, 7], [4, 6, 7, 7], [6, 7], [6, 7, 7], [7,7], [4,7,7]]

说明:

  • 给定数组的长度不会超过15。
  • 数组中的整数范围是 [-100,100]。
  • 给定数组中可能包含重复数字,相等的数字应该被视为递增的一种情况。

 

子序列最大的问题就是:不能打破原数组的顺序。所以我之前的错误思路如下:

    private void backtracking(int[] nums, int startIndex, int depth) {
        // System.out.println("" + depth+ "  " + path.toString());
        if (path.size() >= 2) {
            result.add((ArrayList) path.clone());
        }

        
        int preMax = -101;
        for (int i = startIndex; i < nums.length; ++i) {
            if (i > startIndex && nums[i] == preMax) {
                //System.out.println(path.toString());
                continue;
            }
            preMax = Math.max(preMax, nums[i]);
            
            if (path.isEmpty() || nums[i] >= path.get(path.size()-1)) {
                path.add(nums[i]);
                backtracking(nums, i+1, depth+1);
                path.remove(path.size()-1);
            } 
            // else {
            //     backtracking(nums, i+1, depth+1);
            // }
        }
    }

这里我想的是,在回溯树的一次向下延申中,不能有和当前元素相同的元素出现,即不能同时将2+个相同元素连续加入path中。

但是这样会出现一个问题:例如数组[1 2 3 4 5 1 1 1 1 1]:

  • 对与数组刚开始的1,有path:[1, 1]
  • 对于数组的第二个1,也有path:[1,1]

由此可以发现:

  本题要求,在回溯树每一层的遍历中,是不允许有任一元素重复加入path中。因为number第一次出现时,是从number——last number依次遍历下去的,这次遍历就将number第二次出现可能出现的所有path都遍历过了。所以进行以下处理:

    private void backtracking(int[] nums, int startIndex) {
        //System.out.println("" + depth + "  " + path.toString());
        if (path.size() >= 2) {
            result.add((ArrayList) path.clone());
        }

        Set<Integer> preElement = new HashSet<>();
        for (int i = startIndex; i < nums.length; ++i) {
            //在本层回溯树的遍历过程中,是不能有元素连续开启回溯的
            if (preElement.contains(nums[i])) {
                continue;
            } else {
                preElement.add(nums[i]);
            }

            if (path.isEmpty() || nums[i] >= path.get(path.size()-1)) {
                path.add(nums[i]);
                backtracking(nums, i+1);
                path.remove(path.size()-1);
            } 
        }
    }

 

以上是关于回溯——491.递增子序列的主要内容,如果未能解决你的问题,请参考以下文章

LeetCode_491 递增子序列 /大厂笔试题讲解

491 Increasing Subsequences 递增子序列

力扣算法JS LC [491. 递增子序列] LC [332. 重新安排行程]

算法 ---- LeetCode回溯系列问题题解

算法 ---- LeetCode回溯系列问题题解

算法 ---- LeetCode回溯系列问题题解